//---------------------------------------------------------------------------
// MiniFuncs.cpp
// 
// Written by:   ????
// Last Updated: ?????
//
// Description
// This file defines several global test functions
// for using a MiniStack class... assumed to be defined elsewhere.
//
// Be sure this file defines all the functions 
// declared in the file: miniFuncs.cpp
//
// Changes to this file are required - delete this line to begin with
//
//---------------------------------------------------------------------------
#include <iostream>
#include <algorithm>    // may want to use std::transform and ::tolower
#include "MiniFuncs.h"
#include "MiniStack.h"

using namespace std;        // Use C++ Standard namespace


// Implement the three methods below  --- delete this line

//---------------------------------------------------------------------------
// isPalindrome
// Determine if the string sent is a palindrome
// Return true if reversed string is the same as the original
//             Note: when comparing, ignore spaces and case
//             Example: "ABBa" is a palindrome
//             Example: "step on no pets" is a palindrome
// else return false
//---------------------------------------------------------------------------
bool isPalindrome(string str)
{
   MiniStack<char> palStack;   // must use a stack of chars somehow
	
   // May want to begin by converting str to all lowercase
   // Suggest do a google search on std::string to lower case 
   // or similar
   // Then remove all the spaces
   // Then use a stack to reverse the string (all lowercase and no spaces)
   // Then compare reversed string to forward string with no spaces and all lowercase
   //
   // There may be other/better ways
   
   // write code here
   
}

//---------------------------------------------------------------------------
// balancedParentheses
// [put description here]  <--- notice this --- delete this line and do it
//---------------------------------------------------------------------------
bool balancedParentheses(string equation)
{
   // write code here 
   // --- could you somehow call balancedBlocks(equationWithJustParens) 
   //     by first reducing equation to just open and closed parentheses ?
   //     if yes, might not need to have a local stack variable here
   //     and likely save some coding and time
   //
   // --- if not, there are other options and ways to do this
}

//---------------------------------------------------------------------------
// balancedBlocks
// [put description here] <--- notice this --- delete this line and do it
//
// Could base this code on something like Algorithm ParenMatch(X, n)
// in the book on page 205 -- code fragment 5.11
// Note the difference between book's pop() and yours
//
// May also be other (better?) options
//---------------------------------------------------------------------------
bool balancedBlocks(string code)
{
   // suggest starting with something like
   //MiniStack<char> myStack;   // starts empty
   //bool retVal = true;
   //int i = 0;
   
   // while loop ? while ((retVal == true) && (i < code.size() ) ?
   // similar to book's for-loop with n = code.size() and X = code
   
   // write code here
   
   //return retVal;
}

//---------------------------------------------------------------------------
// file ends
