//---------------------------------------------------------------------------
// MiniFuncs.h
// 
// Written by:   ????
// Last Updated: ?????
//
// Description
//  - delete this line and write something appropriate and useful -
//
//  - changes to this file are required - delete this line too -
//
//---------------------------------------------------------------------------
#pragma once

#include <iostream>
#include <vector>       // std::vector class used by object composition
#include "MyExcept.h"   // for underflowError exception
using namespace std;

//---------------------------------------------------------------------------
// Template DECLARATION of class MiniStack                    BEGINS
// 
// There is nothing in this section that should be changed
//
// Look farther below for where you must make changes
//
//---------------------------------------------------------------------------
template <typename T>
class MiniStack
{
	public:
		MiniStack();
			// constructor. create an empty stack

		void push(const T& item);
			// push (insert) item onto the stack.
			// Postcondition: the stack has a new topmost element and
			// the stack size increases by 1

		T pop();
			// remove and return the item from the top of the stack.
			// Precondition: the stack is not empty.
			// if the stack is empty, the function throws
			// the underflowError exception
     
		T& top();
			// return a reference to the element on the top
			// of the stack.
			// Precondition: the stack is not empty.
			// if the stack is empty, the function throws
			// the underflowError exception
		const T& top() const;
			// constant version of top()

		bool empty() const;
			// determine whether the stack is empty

		int size() const;
			// return the number of elements in the stack

	private:
    	vector<T> m_stackVector;
			// a vector object maintains the stack items and size
};

//---------------------------------------------------------------------------
// Template DECLARATION of class MiniStack                    ENDS
//
// Below you will find the DEFINITION of template class MiniStack
// This is a strange oddity in C++ that requires 
// the template declaration and template definition to be in the same file
//
// Technically this is all still declaration as the 
// complete definition does not occur until the type is specified...
// --- and then the compiler does all the work for you =)
//
// There is code you MUST fill-in for this assignment below
//
// --->   Delete this line because Dr. Dingle wrote it  <----
//
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
// Constructor
//---------------------------------------------------------------------------
template <typename T>
MiniStack<T>::MiniStack()
{
   // anything to do here ?
}

//---------------------------------------------------------------------------
// push(item)
// push item on the stack by inserting it at the end of the vector
// use vector function push_back
//---------------------------------------------------------------------------
template <typename T>
void MiniStack<T>::push(const T& item)
{
	// ?????
}

//---------------------------------------------------------------------------
// pop()
// if ( empty() ) then
//      throw underflowError("MiniStack pop(): stack empty");
// else
//      pop an item from the top of the stack 
//      by removing the item at the end of the vector
//      and return a copy of what it was.
//      use std::vector functions back and pop_back
//---------------------------------------------------------------------------

// write code here


//---------------------------------------------------------------------------
// top
// if ( empty() ) then
//      throw underflowError("MiniStack top(): stack empty");
// else
//     the top of the stack is at the rear of the vector	
//     so return the element at the end of the vector
//      use std::vector function back()
//---------------------------------------------------------------------------

// write code here



//---------------------------------------------------------------------------
// const top
//    constant version of top() with same internal method code
//      use std::vector function back()
//---------------------------------------------------------------------------
template <typename T>
const T& MiniStack<T>::top() const
{
   // write code here
}

//---------------------------------------------------------------------------
// empty
// if MiniStack size is 0 then true, otherwise false
//      use std::vector function empty()
//---------------------------------------------------------------------------


// write code here


//---------------------------------------------------------------------------
// size
// return number of elements in the MiniStack
//      use std::vector function size()
//---------------------------------------------------------------------------

// write code here



//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
// file ends flarf noodles
